// maf_project.c -- extract maf-file entries that name a given source.
// Put that component in the top row, and order alignments by starting position
// in the source sequence.

#include "lib.h"
#include "maf.h"
#include "mz_util.h"

static int compar(struct mafAli **a, struct mafAli **b) {
	int i = (*a)->components->start, j = (*b)->components->start;

	if (i > j)
		return 1;
	else if (i < j)
		return -1;
	return 0;
}

int main(int argc, char **argv) {
	struct mafFile *mf;
	struct mafAli *a, *A = NULL, **align;
	struct mafComp *c, *b;
	int i, nalign = 0;
	FILE *fp;

	if (argc != 3 && argc != 4)
		fatal("args: maf-file source-seq [filename-for-other-mafs]");
	fp = (argc == 4 ? ckopen(argv[3], "w") : NULL);
	mafWriteStart(stdout, "maf_project");
	mf = mafOpen(argv[1], 1);
	while ((a = mafNext(mf)) != NULL) {
		for (c = a->components; c != NULL; c = c->next)
			if (same_string(c->src, argv[2]))
				break;
		if (c != NULL) {
			if (c != a->components) {
				for (b = a->components;
				  b != NULL && b->next != c; b = b->next)
					;
				if (b == NULL)
					fatal("maf_project: cannot happen");
				b->next = c->next;
				c->next = a->components;
				a->components = c;
			}
			a->next = A;
			A = a;
			++nalign;
		} else if (fp != NULL)
			mafWrite(fp, a);
	}
	align = ckalloc(nalign*sizeof(struct mafAli *));

	for (i = 0 ; A != NULL; A = A->next, ++i)
		align[i] = A;
	if (i != nalign)
		fatal("Cannot happen");
	qsort((void *)align, (size_t)nalign, sizeof(struct mafAli *),
	  (void *)compar);

	for (i = 0; i < nalign; ++i)
		mafWrite(stdout, align[i]);

	return 0;
}
